/*
	MAIN FILE DEL PROGRAMMA PLAYCD

	PLAYCD E" UN PROGRAMMA DI DIMOSTRAZIONE PER L'UTILIZZO DELLA CLASSE
	CDROM

	Copyright (c) 1994~1995 Marco Savegnago

	Il programma gira su un PC 486 collegato a:

	1	Fonte di riproduzione realizzata da un array di CDROM
		SONY SCSI comandati tramite un'interfaccia SCSI-2
		Adaptec compatibile


	Il programma e' scritto facendo uso intenso dei costrutti propri
	del C++ ma se si esclude di dover modificare le parti a piu' basso
	livello del codice chiunque abbia una buona conoscenza del linguaggio
	C non dovrebbe trovare difficolta' a capire il funzionamento.

	In sintesi il funzionamento puo' essere cosi' descritto:

	Definizione dei dispositivi di riproduzione (CDROM), lettura
	automatica dal driver del numero di periferiche, numero di
	brani etc etc.

	Esecuzione casuale e continua di tutti i brani dei CDROM con verifica
	dell'effettivo funzionamento.

*/

#include "cdmgr.h"
#include "reboot.h"


#include <conio.h>
#include <iostream.h>
#include <ctype.h>
#include <stdlib.h>
#include <dir.h>
#include <string.h>
#include <stdio.h>
#include <time.h>

int	main(int na, char **a)
{
	word	cd=1;
	word	track=1;
	bool	play=true;
	int 	argstep=0;

	/*	Stampa messaggio copyright	*/

	cout	<<	"CD Audio Play ..." << __DATE__ << "\n"
			<<	"Copyright (c) 1994~1995 Marco Savegnago\n" << endl;

	if(na > 1)
	{
	  for(int i=1;i<na;i++)
	  {
		 char *p=a[i];
		 if(*p=='-'||*p=='/')
		 {
			p++;
			switch(toupper(*p))
			{

				case '?':      // /? o /H mostra help screen
				case 'H':
					cout 	<<  "CD Audio Play ...\n"
							<<	"Copyright (c) 1994~1995 Marco Savegnago\n"
							<<  "uso:\n"
							<<  "PLAYCD /opzioni [play|stop] [cdnum] [tracknum]\n"
							<<	"Opzioni:\n"
							<<	"/H			Mostra questo testo"					<<	endl
							<< 	endl;

					return 1;

			   default:
					break;
			}
		 }
		 else if(!stricmp(p,"PLAY"))
		 {
			play=true;
		 }
		 else if(!stricmp(p, "STOP"))
		 {
			play=false;
		 }
		 else if(isdigit(*p))
		 {
			switch(argstep)
			{
				case	0:
					cd=atoi(p);
					break;
				case	1:
					track=atoi(p);
					break;
				default:
					break;
			}
			argstep++;
		 }
	  }
	}


	/*	Alloco i cdroms	*/

	AllocCDROMS(255, 10);

	int	numOfCdroms	=	cdroms->getNumOfDrives();

	if(numOfCdroms)
	{
		cout	<< "Found -> " << numOfCdroms << " CDROMs" << endl;

		if(cd <=  numOfCdroms)
		{
			if(play)
				cdroms->PlayCD(cd,  track);
			else
				cdroms->StopCD(cd);
		}
	}

	delete cdroms;

	return 0;
}
